package data

import (
	"context"
	"eta/eta_task/services/alarm_msg"
	"eta/eta_task/utils"
	"fmt"
)

// SyncZhongJiIndexList 同步中基宁波指标列表
func SyncZhongJiIndexList(cont context.Context) (err error) {
	defer func() {
		if err != nil {
			tips := "SyncJiaYueNewIndex-同步中基宁波指标列表失败, ErrMsg:\n" + err.Error()
			utils.FileLog.Info(tips)
			go alarm_msg.SendAlarmMsg(tips, 3)
		}
	}()

	param := make(map[string]interface{})
	uri := "smm/zhongji/list"
	res, e := postRefreshEdbData(param, uri)
	if e != nil {
		err = fmt.Errorf("postRefreshEdbData err: %s", e.Error())
		return
	}
	if res != nil && res.Ret != 200 {
		err = fmt.Errorf("postRefreshEdbData fail")
		return
	}
	return
}
